  //Video-Library
  import processing.video.*;
  Capture cam;
  PImage img;
  PImage imgCrop;
  
  //Aufläsung der Kamera und Größe des Rasters
  int myWidth = 640;
  int myHeight = 480;
  int mazeSize = 10;
  int gridWidth = myWidth / mazeSize;
  int gridHeight = myHeight / mazeSize;
  
  //Start- und Endwerte für die einzelnen Felder des Rasters
  int xPixelStart = 0;
  int xPixelEnd = gridWidth;
  int yPixelStart = 0;
  int yPixelEnd = gridHeight;
  
  //Arrays für Farbe aller Pixel und aller Rasterfelder
  color[][] colorsPixels = new color[myWidth][myHeight];
  color[][] colorsGrid = new color[mazeSize + 2][mazeSize + 2];
  
  //Arrays für Position und offene Wege für alle Rasterfelder
  int[][] points = new int[gridWidth][gridHeight];
  int[][] ways = new int[gridWidth][gridHeight];
  
  //Array für Punkte der Lösung und Parameter
  int[][] solution = new int[gridWidth][gridHeight];
  int k = 1;
  
  //Array für Kreuzungen (Punkte mit mehr als einem offenen Weg
  int[] xCrossings;
  int[] yCrossings;
  
  //Anzahl der Kreuzungen im Labyrinth
  int crossingsCount = 0;
  
  //Farbwerte für schwarz und weiß
  color white = -1;
  color black = -16777216;
  
  //Anzahl der Wiederholungen
  int count = 0;
  
  //Umschalten zwischen Aufnahme und Lösen
  boolean record = true;
  int solve = 1;
  
  //Start- und Endpunkt des Labyrinths
  int xStart = 1;
  int yStart = 1;
  int xEnd = 10;
  int yEnd = 10;
  int x = xStart;
  int y = yStart;
  
  //Größe des Bildausschnitts, abhängig vom Aufbau
  int imgXStart = 150;
  int imgYStart = 17;
  int imgXEnd = 406;
  int imgYEnd = 408;
  
void setup() {

  surface.setSize (myWidth, myHeight);
  
  //Aufnahme durch Webcam
  cam = new Capture (this, myWidth, myHeight);
  cam.start();
}

void keyReleased() {
  if (key == '.') {
    solve *= -1;
    record = true;
  }
}

void draw() {

  if (record == true) {
    
    if (cam.available()) cam.read();
    
  //binärer Schwarz-Weiß-Filter
    cam.filter (THRESHOLD, 0.7);
    image(cam, 0, 0);
  
    if (solve == -1) {
      
  //Aufnahme und Zuschneiden des Screenshots
      saveFrame("kuerbis.png");
      img = loadImage("kuerbis.png");
      imgCrop = img.get(imgXStart, imgYStart, imgXEnd, imgYEnd);
      imgCrop.resize(640, 480);
      image(imgCrop, 0, 0);
      
    
  //füllt Array für Farbwerte jedes Pixels 
      for (int xPixels = 0; xPixels < myWidth; xPixels++) {
        for (int yPixels = 0; yPixels < myHeight; yPixels++) {
          
          colorsPixels[xPixels][yPixels] = get(xPixels, yPixels);
        }
      }
    
  //unterteilt Bild in ein Raster
      for (int xG = 0; xG <= mazeSize + 1; xG++) {
        for (int yG = 0; yG <= mazeSize + 1; yG++) {
        
          int whiteCount = 0;
        
  //zählt die weißen Pixel in den Feldern des Rasters
          if (xG >= 1 && xG <= mazeSize && yG >= 1 && yG <= mazeSize) {
            for (int xGridPixels = xPixelStart; xGridPixels < xPixelEnd; xGridPixels++) {
              for (int yGridPixels = yPixelStart; yGridPixels < yPixelEnd; yGridPixels++) {
              
                if (colorsPixels[xGridPixels][yGridPixels] == white) whiteCount++;
                else whiteCount--;
              }
            }
  //springt zum nächsten Feld in y-Richtung
            yPixelStart += gridHeight;
            yPixelEnd += gridHeight;
          }
  //speichert das Feld abhängig von whiteCount als schwarz oder weiß
          if (whiteCount > 0) colorsGrid[xG][yG] = white;
          else colorsGrid[xG][yG] = black;
        }
        
        if(xG >= 1 && xG < mazeSize + 1) {
  //springt zum nächsten Feld in x-Richtung
          xPixelStart += gridWidth;
          xPixelEnd += gridWidth;
  //fängt wieder am Anfang der Spalte an
          yPixelStart = 0;
          yPixelEnd = gridHeight;
        }
      }

  //zählt umliegende weiße Pixel
      for (int w = 1; w <= mazeSize; w++) {
        for (int h = 1; h <= mazeSize; h++) {
          if (colorsGrid[w + 1][h] == white) ways[w][h]++;
          if (colorsGrid[w - 1][h] == white) ways[w][h]++;
          if (colorsGrid[w][h + 1] == white) ways[w][h]++;
          if (colorsGrid[w][h - 1] == white) ways[w][h]++;
      
  //mögliche Wege = umliegende weiße Pixel - 1, da man von einem herkommt
        if (colorsGrid[w][h] == white) ways[w][h]--;
        else ways[w][h] = 0;
        
  //mögliche Wege für Sackgassen = 1, damit diese auch als Teil des Labyrinths erkannt werden
        if (colorsGrid[w][h] == white && ways[w][h] == 0) ways[w][h] = 1;
      
  //Anzahl der Kreuzungen = Anzahl der Pixel mit mehr als einem möglichen Weg
        if (ways[w][h] >= 2) crossingsCount++;
        }
      }
      
  //anpassen der möglichen Wege für Start- und Endpunkt
      ways[xEnd][yEnd] = 1;
      ways[xStart][yStart] = 1;
      
  //Arrays für genaue Positionen der Kreuzungen
      xCrossings = new int[crossingsCount + 1];
      yCrossings = new int[crossingsCount + 1];
      
      record = false;
    }
  } else {
  
  //nachdem einmal '.' gedrückt wurde beginnt der Lösungsalgorithmus
  //zählt Durchläufe / Wiederholungen
    count++;
  
  //beendet das Programm, wenn Zielpunkt erreicht ist und zeichnet den Weg ein
    if (x == xEnd && y == yEnd) {
      println("yaaaaay!");
      println("benötigte Durchläufe: " + count);
      
      for (int w = 0; w <= mazeSize; w++) {
        for (int h = 0; h <= mazeSize; h++) {
          if (solution[w][h] >= 1) {
            fill(255, 0, 0);
            ellipse((w - 0.5) * gridWidth, (h - 0.5) * gridHeight, gridWidth, gridHeight);
            ellipse(myWidth - (0.5 * gridWidth), myHeight - (0.5 * gridHeight), gridWidth, gridHeight);
          }
        }
      }
      noLoop();
    }
  
  //speichert aktuellen Punkt als neue Kreuzung, wenn mehr als 1 möglicher Weg vorhanden ist
    if (ways[x][y] > 1 && solution[x][y] == 0) {
      for (int i = crossingsCount - 1; i >= 0; i--) {
        xCrossings[i + 1] = xCrossings[i];
        yCrossings[i + 1] = yCrossings[i];
      }
      xCrossings[0] = x;
      yCrossings[0] = y;
  //erhöht Parameter
      k++;
      }
  
  //bewegt aktuellen Punkt weiter und verringert die möglichen Wege des aktuellen Punkts
  //speichert dabei den aktuellen Punkt als Teil des Lösungsweges
    if (colorsGrid[x][y + 1] == white && ways[x][y + 1] != 0 && solution[x][y + 1] == 0) {
      ways[x][y]--;
      solution[x][y] = k;
      y++;
    }
    else if (colorsGrid[x - 1][y] == white && ways[x - 1][y] != 0 && solution[x - 1][y] == 0) {
      ways[x][y]--;
      solution[x][y] = k;
      x--;
    }
    else if (colorsGrid[x][y - 1] == white && ways[x][y - 1] != 0 && solution[x][y - 1] == 0) {
      ways[x][y]--;
      solution[x][y] = k;
      y--;
    }
    else if (colorsGrid[x + 1][y] == white && ways[x + 1][y] != 0 && solution[x + 1][y] == 0) {
      ways[x][y]--;
      solution[x][y] = k;
      x++;
    }
    else {
  //wenn keine Wege mehr möglich sind, wird zur letzten Kreuzung zurückgesprungen
      ways[x][y]--;
      x = xCrossings[0];
      y = yCrossings[0];
  
  //nach dem Zurückspringen werden alle Punkte, die zwischen der letzten Kreuzung und dem letzten Punkt liegen aus der Lösungmenge gelöscht
      for (int w = 0; w <= mazeSize; w++) {
        for (int h = 0; h <= mazeSize; h++) {
          
          if (solution[w][h] == k) {
            solution[w][h] = 0;
          }
        }
      }
      solution[x][y] = k;
      
  //wenn nur noch ein Weg an der letzten Kreuzung offen ist, wird diese als Kreuzung gelöscht und Kreuzungen werden aktualisiert
  //der Parameter wird verringert
      if (ways[x][y] == 1) {
        for (int j = 0; j < crossingsCount; j++) {
          xCrossings[j] = xCrossings[j + 1];
          yCrossings[j] = yCrossings[j + 1];
        }
        k--;
        solution[x][y] = k;
      }
      
  //wenn an der letzten Kreuzung kein Weg mehr frei ist, wird zur vorletzten Kreuzung zurückgesprungen
      if (ways[x][y] == 0) {
        x = xCrossings[0];
        y = yCrossings[0];
  
  //nach dem Zurückspringen werden alle Punkte, die zwischen der vorletzten Kreuzung und dem letzten Punkt liegen aus der Lösungmenge gelöscht
        for (int w = 0; w <= mazeSize; w++) {
          for (int h = 0; h <= mazeSize; h++) {
          
            if (solution[w][h] == k) {
              solution[w][h] = 0;
            }
          }
        }
        solution[x][y] = k;
      }
   
    }
  
  }
}